#include <stdio.h>
#include <stdlib.h>
#include <io.h>

#define Z 'Z'
#define NOT_EXIST 10
#define INTERVAL 100L
#define ARGNO 2
#define CHANGED_MIND 11
#define ANSLEN 34

long overwrite ( char *file_name );



void main( int argc, char **argv )
{
   int fno;
   long bytes;
   char *fname,
	    answer [ANSLEN],
     ans2 [ANSLEN];


	  if( argc != ARGNO )
		{
		printf( "\n\nWhich file do you wish to delete? " );
		gets( answer );
		fname = answer;
		}
	  else
		fname = argv [1];

	  printf( "\n\nAre you sure you want to delete %s? ", fname );
	  gets( ans2 );
		if( *ans2 != 'y' && *ans2 != 'Y')
		   exit( CHANGED_MIND );

	  bytes = overwrite ( fname );

	  unlink ( fname );

	  printf( "\n%ld bytes have been overwritten.", bytes );
	  printf( "\nThe file %s has been destroyed!", fname );

}


long overwrite ( char *filename )
{
  long int count = 0l,
		 flen;
   FILE *fp;
   
	 if( NULL == ( fp = fopen( filename, "r+b" ) ) )
	    {
	    puts( "No such file exists!" );
	    exit( NOT_EXIST );
	    }   

	  flen = filelength( fileno( fp ) );

	  while( EOF != ( fgetc( fp ) ) )
		{
		fseek( fp, -1, SEEK_CUR );
		fputc( Z, fp );
		fseek( fp, 0, SEEK_CUR );
		count++;
      if( !( count%INTERVAL ) )
		printf( "\n%ld characters overwritten so far, out of %ld. ",
			   count, flen );
		}

	 fclose ( fp );	

	 return ( count );

}
